Unit astoe_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure astoe(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; var A1 :Array of Extended;
                var B1 :Array of Extended; M :Integer);

implementation

procedure astoe(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; var A1 :Array of Extended;
                var B1 :Array of Extended; M :Integer);
var
J,K,KJ :Integer;
FKK,RK,SK :Extended;
label
_10,_20,_30;
begin
A1[0] := 1.e0/A[0];
X[0] := B[0]*A1[0];
B1[0] := 0.e0;
for K:=2 to M do
 begin
  A1[K-1] := 0.e0;
  X[K-1] := 0.e0;
  RK  := 0.e0;
  FKK  := 0.e0;
  for J:=2 to K do
   begin
    KJ  := K - J + 1;
    B1[J-1] := A1[KJ-1];
    RK  := RK + A[J-1]*B1[J-1];
    FKK  := FKK + A[J-1]*X[KJ-1];
_10:
   end;
  FKK  := B[K-1] - FKK;
  SK  := 1.e0/(1.e0 - RK*RK);
  RK  := -RK*SK;
  for J:=1 to K do
   begin
    KJ  := K - J + 1;
    A1[J-1] := A1[J-1]*SK + B1[J-1]*RK;
    X[KJ-1] := X[KJ-1] + A1[J-1]*FKK;
_20:
   end;
_30:
 end;
end;

end.
